setlocal

set PROGRAMID=Siris
set PROGRAMTITLE=Siris
set FILEEXT=siris

if "%1" == "/1" goto :1

rem Between pre and post, Sup.exe is moved to _update if within ProgramPath.
rem In regular install mode, new Sup.exe is extracted from the archive in its
rem place and is usable; in /uninstall mode there's none so we use the moved one.
rem The moved SUP_EXE is not used in install mode to avoid creating a service
rem that will run from _update\Sup.exe, not from ProgramPath\Sup.exe.
set CONFIG=%SUP_EXE:.exe=.json%
if not exist "%CONFIG%" (
  echo >"%CONFIG%" {"VersionURL": "disabled://", "ProgramID": "%PROGRAMID%", "ProgramTitle": "%PROGRAMTITLE%", "ProgramPath": "%CD:\=\\%"}
)

rem --- Delete shortcuts for All Users ---
del /f "%PUBLIC%\Desktop\%PROGRAMTITLE%.lnk"
del /f "%ALLUSERSPROFILE%\Microsoft\Windows\Start Menu\%PROGRAMTITLE%.lnk"

rem --- Delete file association ---
if not %FILEEXT% == "" (
  assoc .%FILEEXT%=
  ftype %PROGRAMID%=
)

rem Using %SUP_EXE%, not Sup.exe because in Uninstall/post it may be in _update,
rem missing from ProgramPath (CWD).
"%SUP_EXE%" /pipe - "%~dpf0" /1

if exist "%~dp0extra.bat" call "%~dp0extra.bat"

rem Delete Sup.exe left in _update, and possibly other folders busy during /uninstall.
rem Sanity check for %CD% to ensure we don't wipe a different folder.
start "" /d \ /b cmd /c "if "%CD%\_update\post\run.bat" == "%~0" for %%i in (1 2 3 4 5) do timeout 1 & rd /s /q "%CD%" && exit"

exit /b 0

:1
rem --- Delete shortcuts for the current user ---
del /f "%USERPROFILE%\Desktop\%PROGRAMTITLE%.lnk"
del /f "%APPDATA%\Microsoft\Windows\Start Menu\%PROGRAMTITLE%.lnk"

rem --- Remove program-specific per-user data for the current user ---
rd /s /q "%APPDATA%\Soletude\%PROGRAMID%"
reg delete "HKCU\Software\Soletude\%PROGRAMID%" /f /reg:32
reg delete "HKCU\Software\Soletude\%PROGRAMID%" /f /reg:64

rem --- Remove Sup's files except for logs (which are still opened) ---
rd /s /q "%APPDATA%\Soletude\Sup\%PROGRAMID%\Backups"
rd /s /q "%APPDATA%\Soletude\Sup\%PROGRAMID%\Updates"
exit /b
